#ifdef USE_GLFW

#include <GLFW/glfw3.h>
#include <gearlib.h>

const char* gr_platform_get_name() {
    return "GLFW";
}

bool gr_platform_init() {
    if(glfwInit() != GLFW_TRUE) {
        return false;
    }

    return true;
}

void* gr_platform_create_window(i32 width, i32 height, const char* title) {
    glfwWindowHint(GLFW_CONTEXT_VERSION_MAJOR, gr_state_get(major));
    glfwWindowHint(GLFW_CONTEXT_VERSION_MINOR, gr_state_get(minor));
    glfwWindowHint(GLFW_OPENGL_PROFILE, GLFW_OPENGL_CORE_PROFILE);
    glfwWindowHint(GLFW_OPENGL_FORWARD_COMPAT, GL_TRUE);

    GLFWwindow* window = glfwCreateWindow(width, height, title, NULL, NULL); 
    if(window == NULL) {
        glfwTerminate();
        return NULL;
    }

    glfwMakeContextCurrent(window);
    return window;
}

bool gr_platform_window_should_close() {
    glfwPollEvents();
    glfwSwapBuffers(gr_state_get(window));
    return glfwWindowShouldClose(gr_state_get(window));
}

gr_load_proc gr_platform_get_load_proc() {
    return (gr_load_proc)glfwGetProcAddress;
}

#endif
