#ifdef USE_SDL

#include <SDL2/SDL.h>
#include <gearlib.h>

const char* gr_platform_get_name() {
    return "SDL2";
}

bool gr_platform_init() {
    if(SDL_Init(SDL_INIT_VIDEO) != 0) {
        return false;
    }

    return true;
}

void* gr_platform_create_window(i32 width, i32 height, const char* title) {
    SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
    SDL_GL_SetAttribute(SDL_GL_ACCELERATED_VISUAL, 1);
    SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 8);
    SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 8);
    SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 8);
    SDL_GL_SetAttribute(SDL_GL_ALPHA_SIZE, 8);

    SDL_GL_SetAttribute(SDL_GL_CONTEXT_MAJOR_VERSION, gr_state_get(major));
    SDL_GL_SetAttribute(SDL_GL_CONTEXT_MINOR_VERSION, gr_state_get(minor));
    SDL_GL_SetAttribute(SDL_GL_CONTEXT_PROFILE_MASK, SDL_GL_CONTEXT_PROFILE_CORE);
    SDL_GL_SetAttribute(SDL_GL_CONTEXT_FLAGS, SDL_GL_CONTEXT_FORWARD_COMPATIBLE_FLAG);
    
    SDL_Window* window = SDL_CreateWindow(title, SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED, 
                                          width, height,SDL_WINDOW_OPENGL | SDL_WINDOW_SHOWN);
    if(window == NULL) {
        SDL_Quit();
        return NULL;
    }

    SDL_GL_CreateContext(window);
    return window;
}

bool gr_platform_window_should_close() {
    SDL_Event event;
    while (SDL_PollEvent(&event)) {
        if (event.type == SDL_QUIT) {
            return true;
        }
    }

    SDL_GL_SwapWindow(gr_state_get(window));
    return false;
}

gr_load_proc gr_platform_get_load_proc() {
    return (gr_load_proc)SDL_GL_GetProcAddress;
}

#endif
